Bug 454407 - running udevtrigger in X causes strange X behavior
running udevtrigger in X causes strange X behavior
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: dkms (Show other bugs)
9
All Linux
low Severity low
: ---
: ---
Assigned To: Mario Limonciello
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-07-08 06:59 EDT by Marina Fadeeva
Modified: 2009-06-15 21:42 EDT (History)
8 users (show)

See Also:
Fixed In Version: 2.0.21.1-2.fc11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-20 19:56:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Marina Fadeeva 2008-07-08 06:59:37 EDT
Description of problem:
If you run /sbin/udevtrigger in X, mouse movement becomes erratic (it's hardly
possible to control the mouse) and pressing a single keyboard button in terminal
results many symbols on the screen. Sometimes network connections drops down.
The problem is reproducible only on FC9 (I tried x86 and x86_64) with all recent
updates and does not depend on X window manager - reproduced in KDE, GNOME and
in XFCE on 3 different systems. I was unable to reproduce the described behavior
on FC7.

Version-Release number of selected component (if applicable):
# rpm -qf /sbin/udevtrigger
udev-124-1.fc9.2.x86_64


How reproducible:
run "/sbin/udevtrigger" 

Steps to Reproduce:
1. start KDE/GNOME or XFCE - doesnt matter.
2. Open X-terminal
3. run "/sbin/udevtrigger"
4. Try to type anything in terminal.
  
Actual results:
mouse and keyboard cant be normally controlled anymore. X-server must be
restarted in order to "fix" the issue.

Expected results:
Xserver should not be affected. 

Additional info:
dkms (dkms-2.0.19.1-1.fc9) calls "/sbin/udevtrigger" during module installation.
So after you build and install some module using dkms in X, you should restart
Xserver in order to be able to work normally.
Comment 1 Harald Hoyer 2008-07-08 07:03:38 EDT
dkms MUST NOT call udevtrigger.. udev resets all permissions, if you do that.
Comment 2 Matt Domsch 2008-07-08 08:27:05 EDT
https://bugzilla.redhat.com/show_bug.cgi?id=238383
shows an ack by Harald and Kay to add this behavior.  Has something changed in
udev since then?
Comment 3 Matt Domsch 2008-07-08 08:29:07 EDT
Adding Kay and Jon; this has the potential to affect Jon's KMODs too.
Comment 4 Matt Domsch 2008-08-07 10:25:40 EDT
ping udev guys.  If tools shouldn't call udevtrigger, then it should not be an easily-accessible app to run.  Perhaps a udevtrigger --nochangeperms  or somesuch option would be better?
Comment 5 Kay Sievers 2008-08-07 15:57:46 EDT
Recent udev does not change permissions, it restores the permissions specified in the rules if they do not match the current perms of the node, they are not touched otherwise.

In theory, all apps should handle "duplicated" events, which udevtrigger causes, but in real world some apps get confused by this. So, yes, it should be avoided to run udevtrigger.

Why does dkms want to run udevtrigger? The loading of the module should generate all needed events and do all what is needed, right? How is that different from a device hotplug case?
Comment 6 Matt Domsch 2008-08-07 16:51:37 EDT
DKMS does not modprobe/insmod the module.  It only copies it into /lib/modules/$kernelversion and runs depmod.  It started calling udevtrigger a year ago
https://bugzilla.redhat.com/show_bug.cgi?id=238383 so that udev causes the module to get loaded if needed/applicable.

At that time, it was suggested that dkms call udevtrigger.  If that's no longer the case, and there's a "better" way to handle such, please advise.  But having DKMS call modprobe itself isn't really the right answer - it can't do all the "do I need this module" type of checking that udev does.
Comment 7 Harald Hoyer 2008-08-08 09:18:59 EDT
This should do the trick:

# find /sys -name modalias -print0 | xargs -0 cat | xargs /sbin/modprobe -a -v
Comment 8 Harald Hoyer 2008-08-08 09:19:55 EDT
or without "-v" of course
Comment 9 Matt Domsch 2008-08-08 09:26:00 EDT
modaliases appear in /sys  before modules that implement them are loaded?
Comment 10 Harald Hoyer 2008-08-08 09:38:52 EDT
yes, generic <bus>:<vendor_id><device_id> and modules have these aliases
udev does not much more for module loading
Comment 11 Matt Domsch 2008-08-08 10:06:37 EDT
Mario, see comments 7 and 8, and apply accordingly then.
Comment 12 Andrew Ziem 2009-04-15 00:00:00 EDT
This bug seems to manifest itself as CTRL+F2 acting like CTRL+ALT+F2 just after installing VirtualBox until rebooting Fedora 10.
http://www.virtualbox.org/ticket/3117
Comment 13 Matt Domsch 2009-04-15 00:32:13 EDT
dkms 2.0.21.1 has the call to udevadm trigger removed. I suppose I need to get a new version built into fedora then...
Comment 14 Fedora Update System 2009-04-15 08:47:48 EDT
dkms-2.0.21.1-2.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/dkms-2.0.21.1-2.fc10
Comment 15 Matt Domsch 2009-04-15 08:49:32 EDT
================================================================================
     dkms-2.0.21.1-2.fc10
================================================================================
    Release: Fedora 10
     Status: pending
       Type: bugfix
      Karma: 0
    Request: testing
       Bugs: 454407 - running udevtrigger in X causes strange X behavior
      Notes: Removes call to udevadm trigger, which fixes udev resetting
           : permissions on device nodes.  Uses
           : /etc/modprobe.d/dkms.conf per module-init-tools
           : expectations for naming of conf files there. Add
           : Requires: lsb to avoid potential problems with RPM
           : recursion.
  Submitter: mdomsch
  Submitted: 2009-04-15 12:47:41
   Comments: mdomsch - 2009-04-15 12:47:49 (karma 0)
             This update has been submitted for testing

  https://admin.fedoraproject.org/updates/dkms-2.0.21.1-2.fc10
Comment 16 Fedora Update System 2009-04-15 09:09:23 EDT
dkms-2.0.21.1-2.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/dkms-2.0.21.1-2.fc9
Comment 17 Fedora Update System 2009-04-15 14:01:56 EDT
dkms-2.0.21.1-2.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update dkms'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2009-3701
Comment 18 Fedora Update System 2009-04-15 14:02:02 EDT
dkms-2.0.21.1-2.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update dkms'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-3703
Comment 19 Adam Goode 2009-05-13 10:58:32 EDT
Did this miss getting into Fedora 11?
Comment 20 Matt Domsch 2009-05-13 12:18:24 EDT
Yes, it missed Fedora 11. It's sitting in updates-testing for Fedora 9 and 10.  I'll build for updates-testing for Fedora 11 now.
Comment 21 Fedora Update System 2009-05-13 12:21:13 EDT
dkms-2.0.21.1-2.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/dkms-2.0.21.1-2.fc11
Comment 22 Fedora Update System 2009-05-13 22:57:12 EDT
dkms-2.0.21.1-2.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update dkms'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-4960
Comment 23 Fedora Update System 2009-05-20 19:56:39 EDT
dkms-2.0.21.1-2.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2009-05-20 19:59:04 EDT
dkms-2.0.21.1-2.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 Fedora Update System 2009-06-15 21:41:57 EDT
dkms-2.0.21.1-2.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.